/* eslint-disable linebreak-style */
// JavaScript Code genommen und angepasst von local/boostnavigation/amd/src
// User-Preferences erstmal entfernt

// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.

/**
 * Local plugin "Hsh modified Boost course overview on campus"
 * Original: local_boostnavigation
 *
 * @package    local_boostnavigation
 * @copyright  2017 Kathrin Osswald, Ulm University <kathrin.osswald@uni-ulm.de>, Edited by Tobias Baden, Hochschule Hannover
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

define(['jquery'], function($) {
    "use strict";
    var nodesArray = [];

    function toggleClickHandler(node, nodename) {
        node.click(function(e) {
            // Prevent that the browser opens the node's default action link (if existing).
            e.preventDefault();

            if (nodename == "mycourses") {
                // "MyCourses" angeklickt um diesen einzuklappen
                if (node.attr('data-collapse') == 0) {
                    // Alle Semester verstecken
                    nodesArray.forEach(function(semester) {
                        $('.list-group-item[data-key=' + semester + ']').attr("data-collapse", "1");
                        $('.list-group-item[data-key=' + semester + ']').attr("data-hidden", "0");
                        // Not needed if only reopen the newest semester
                        // M.util.set_user_preference('local_hsh_boostnavigation-collapse_' + semester + '_node', 0); //1
                    });

                    // If the parent node is currently collapsed.
                } else if (node.attr('data-collapse') == 1) {
                    // Alle Kurse verstecken
                    nodesArray.forEach(function(nodekey) {
                        // Set the hidden attribute to true for all elements which have the nodename as their data-parent-key attribute.
                        $('.list-group-item[data-parent-key=' + nodekey + ']').attr("data-hidden", "1");
                        $('.list-group-item[data-parent-key=' + nodekey + ']').attr("data-collapse", "1");
                    });

                    // Semester wieder sichtbar machen, Kurse weiterhin verstecken
                    nodesArray.forEach(function(semester) {
                        $('.list-group-item[data-key=' + semester + ']').attr("data-collapse", "1");
                        $('.list-group-item[data-key=' + semester + ']').attr("data-hidden", "1");
                        // Not needed if only reopen the newest semester
                        // M.util.set_user_preference('local_hsh_boostnavigation-collapse_' + semester + '_node', 0); //1
                    });

                }
            } else {
                // Ein Semester angeklickt um dieses auf oder zu zu klappen
                // If the parent node is currently expanded.
                if (node.attr('data-collapse') == 0) {
                    // Set the hidden attribute to true for all elements which have the nodename as their data-parent-key attribute.
                    $('.list-group-item[data-parent-key=' + nodename + ']').attr("data-hidden", "1");
                    // Change the collapse attribute of the node itself to true.
                    node.attr("data-collapse", "1");

                    // Not needed if only reopen the newest semester
                    // M.util.set_user_preference('local_hsh_boostnavigation-collapse_' + nodename + '_node', 0); //1

                    // If the parent node is currently collapsed.
                } else if (node.attr('data-collapse') == 1) {
                    // Set the hidden attribute to false for all elements which have the nodename as their data-parent-key attribute.
                    $('.list-group-item[data-parent-key=' + nodename + ']').attr("data-hidden", "0");

                    // Change the collapse attribute of the node itself to false.
                    node.attr("data-collapse", "0");

                    // Not needed if only reopen the newest semester
                    // M.util.set_user_preference('local_hsh_boostnavigation-collapse_' + nodename + '_node', 1); //0
                }
            }
        });
    }

    function initToggleNodes(nodename) {
        if (nodesArray[0] === "") {
            nodesArray = new Array();
        }

        // Search node to be collapsible.
        var node = $('.list-group-item[data-key="' + nodename + '"]');

        if (nodename === "mycourses") {
            node.attr("data-collapse", "0");
        } else {
            node.attr("data-collapse", "1");
        }

        if (nodename !== "" && nodename !== "mycourses") {
            node.addClass('list-group-item-action semesternode');
            node.attr("data-isexpandable", "1");

            var childNode = $('.list-group-item[data-parent-key=' + nodename + ']');
            childNode.attr("data-hidden", "1");
            childNode.attr("data-collapse", "1");
            childNode.addClass("coursenode");
            /** IE11 kennt kein includes. Im Fall von IE11 ohne Includes arbeiten, Array durchlaufen und manuell Prüfen. */
            if (navigator.userAgent.match(/Trident\/7\./)) {
                if (nodesArray.indexOf(nodename) == -1) {
                    nodesArray.push(nodename);
                }
            } else {
                if (!nodesArray.includes(nodename)) {
                    nodesArray.push(nodename);
                }
            }
        }
        // Add a click handler to this node.
        toggleClickHandler(node, nodename);
    }

    function openNode(nodename) {
        var node = $('.list-group-item[data-key="' + nodename + '"]');
        node.attr("data-hidden", "0");
        node.attr("data-collapse", "0");
        $('.list-group-item[data-parent-key=' + nodename + ']').attr("data-hidden", "0");
        $('.list-group-item[data-parent-key=' + nodename + ']').attr("data-collapse", "0");
    }

    function openSemesterFromSelectedCourse() {
        var url_string = new URL(window.location.href);
        var id = url_string.searchParams.get("id");
        if (id === null) {
            id = url_string.searchParams.get("courseid");
        }
        var courseNode = document.querySelectorAll('a.coursenode[href$="id=' + id + '"]');
        if (typeof courseNode[0] !== "undefined") {
            openNode(courseNode[0].getAttribute("data-parent-key"));
        }
    }

    function openSemesterFromSelectedCourseIE() {
        var url_string = window.location.search;
        var id = url_string.replace("?id=", "");
        if (id === null) {
            id = url_string.replace("?courseid=", "");
        }
        if (id !== null) {
            var courseNode = document.querySelectorAll('a.coursenode[href$="id=' + id + '"]');
            if (typeof courseNode[0] !== "undefined") {
                openNode(courseNode[0].getAttribute("data-parent-key"));
            }
        }
    }

    return {
        init: function(params) {
            for (var i = 0, len = params.length; i < len; i++) {
                initToggleNodes(params[i]);
            }
            if (navigator.userAgent.match(/Trident\/7\./)) {
                // Reopen Semester Function - Internet Explorer Version
                openSemesterFromSelectedCourseIE();
            } else {
                // Reopen Semester Function - Not Internet Explorer
                openSemesterFromSelectedCourse();
            }
        },
        openSemester: function(nodename) {
            openNode(nodename);
        }
    };
});
