<?php
// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.

/**
 * Local plugin "Hsh modified Boost course overview on campus"
 * Original: local_boostnavigation
 *
 * @package    local_hsh_boostnavigation
 * @copyright  2017 Alexander Bias, Ulm University <alexander.bias@uni-ulm.de>, Edited by Tobias Baden, Hochschule Hannover
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

// Code genommen - semester_date.php
// Überarbeitet und angepasst - Tobias Baden HsH

function getSemesterNodeHsH(&$rootNode, $course, &$semesterList, &$semesterKeys) {
    global $PAGE;
    $unabhaengig = 'semesterunabhängig';
    $unabhaengigKey = 'no-semester';

    // Wenn Kurs kein Enddatum hat (Semesterunabhöngigkeit)
    $startday = getFirstDayOfSem($course->startdate);

    if($startday <= 0) {
        // Im Array suchen, ob der Knoten für die Semesterunabhängigen Kurse schon vorhanden ist
        $parent = $semesterList[array_search($unabhaengigKey, $semesterKeys)];
        // Knoten noch nicht vorhanden
        if(!$parent) {
            $parent = navigation_node::create($unabhaengig, null, navigation_node::TYPE_COURSE, $unabhaengig, /* data key */ $unabhaengigKey);
            array_push($semesterList, $parent);
            array_push($semesterKeys, $unabhaengigKey);
        }
    } else {
        // Im Array suchen, ob der Knoten für das Semester schon vorhanden ist
        $parent = $semesterList[array_search($startday, $semesterKeys)];
        // Knoten nicht vorhanden
        if (!$parent) {
            $text = getSem($startday);
            $parent = navigation_node::create($text, null, navigation_node::TYPE_COURSE, $text, /* data key */ $startday);
            array_push($semesterList, $parent);
            array_push($semesterKeys, $startday);
        }
    }
    return $parent;
}
?>
